/*
  This is a test sketch for the Adafruit assembled Motor Shield for Arduino v2
  It won't work with v1.x motor shields! Only for the v2's with built in PWM
  control

  For use with the Adafruit Motor Shield v2
  ---->	http://www.adafruit.com/products/1438
*/
#include <Wire.h>                 // * Подключаем библиотеку для работы с аппаратной шиной I2C.
#include <iarduino_I2C_Bumper.h>  //   Подключаем библиотеку для работы с бампером I2C-flash.
iarduino_I2C_Bumper bum(0x09);

#include <Adafruit_MotorShield.h>

#include <Servo.h>

Servo rservo;
Servo lservo;

const int Trig1 = 9;  // pin ULTRAS перед
const int Echo1 = 8;  // pin ULTRAS перед
long duration;
long distance;
float olderror=0.0;

const int Su = A0;
const int Sd = A1;

// Create the motor shield object with the default I2C address
Adafruit_MotorShield AFMS = Adafruit_MotorShield();
// Or, create it with a different I2C address (say for stacking)
// Adafruit_MotorShield AFMS = Adafruit_MotorShield(0x61);

// Select which 'port' M1, M2, M3 or M4. In this case, M1
Adafruit_DCMotor *myMotor = AFMS.getMotor(1); //left
// You can also make another motor on port M2
Adafruit_DCMotor *myOtherMotor = AFMS.getMotor(2); //right

void setup() {

  pinMode(Trig1, OUTPUT);
  pinMode(Echo1, INPUT);

  Serial.begin(9600);  // set up Serial library at 9600 bps
  Serial.println("Adafruit Motorshield v2 - DC Motor test!");
  bum.begin();  //   Инициируем работу с бампером.

  if (!AFMS.begin()) {  // create with the default frequency 1.6KHz
    // if (!AFMS.begin(1000)) {  // OR with a different frequency, say 1KHz
    Serial.println("Could not find Motor Shield. Check wiring.");
    while (1)
      ;
  }
  Serial.println("Motor Shield found.");
  myMotor->run(FORWARD);
  myOtherMotor->run(FORWARD);

  rservo.attach(9);
  lservo.attach(10);
}

void proezd(int t,int lv,int rv)
{
  myMotor->run(FORWARD);
  myOtherMotor->run(FORWARD);
  bool usl = 0;
  unsigned long real = millis();
  while (usl == 0) {
    if ((millis() - real) > t) {
      usl = 1;
    }
      myMotor->setSpeed(lv);
      myOtherMotor->setSpeed(rv);
  }
  myOtherMotor->run(RELEASE);
  myMotor->run(RELEASE);
  bum.setTurnSignal(BUM_TURN_EMERGENCY);
  delay(500);
  bum.setTurnSignal(BUM_TURN_OFF);
}

void proezd_bwd(int t,int lv,int rv)
{
  myMotor->run(BACKWARD);
  myOtherMotor->run(BACKWARD);
  bool usl = 0;
  unsigned long real = millis();
  while (usl == 0) {
    if ((millis() - real) > t) {
      usl = 1;
    }
      myMotor->setSpeed(lv);
      myOtherMotor->setSpeed(rv);
  }
  myOtherMotor->run(RELEASE);
  myMotor->run(RELEASE);
  bum.setTurnSignal(BUM_TURN_EMERGENCY);
  delay(500);
  bum.setTurnSignal(BUM_TURN_OFF);
}

void line() {
  float error = bum.getErrPID();
  float upr = (10 * error) + (15 * (error - olderror));
  myMotor->setSpeed(70 - upr);
  myOtherMotor->setSpeed(70 + upr);
  olderror = error;
}

void line_time(int t) {
  myMotor->run(FORWARD);
  myOtherMotor->run(FORWARD);
  bool usl = 0;
  unsigned long real = millis();
  olderror =0;
  while (usl == 0) {
    if ((millis() - real) > t) {
      usl = 1;
    }
    line();
  }
  myOtherMotor->run(RELEASE);
  myMotor->run(RELEASE);
  bum.setTurnSignal(BUM_TURN_EMERGENCY);
  delay(500);
  bum.setTurnSignal(BUM_TURN_OFF);
}

int line_cross() {
  myMotor->run(FORWARD);
  myOtherMotor->run(FORWARD);
  bool usl = 0;
  int side = 0;
  olderror =0;
  while (usl == 0) {
    if (bum.getLineAnalog(9) < 1000 || bum.getLineAnalog(1) < 1000) {
      usl = 1;
    }
    line();
  }
  myOtherMotor->run(RELEASE);
  myMotor->run(RELEASE);
  if (bum.getLineAnalog(9) < 1000 and bum.getLineAnalog(1) < 1000)
  {
    bum.setTurnSignal(BUM_TURN_EMERGENCY);
    side = 5;
  }
  else if (bum.getLineAnalog(9) < 1000 ) {
    bum.setTurnSignal(BUM_TURN_RIGHT);  //   Включаем правый поворотник.
    side = 9;                           // перекресток справа
  }
  else if (bum.getLineAnalog(1) < 1000) {
    bum.setTurnSignal(BUM_TURN_LEFT);  //   Включаем левый поворотник.
    side = 1;                          // перекресток слева
  }
  delay(500);
  bum.setTurnSignal(BUM_TURN_OFF);  //   Выключаем поворотники.
  return side;
}

void turn_2wd(int dir) {
  if (dir == 9) {
    myMotor->run(BACKWARD);
    myOtherMotor->run(FORWARD);
  }
  if (dir == 1) {
    myMotor->run(FORWARD);
    myOtherMotor->run(BACKWARD);
  }
  myMotor->setSpeed(70);
  myOtherMotor->setSpeed(70);
  delay(590);
  myOtherMotor->run(RELEASE);
  myMotor->run(RELEASE);
}


void sonar() {
  // if (calculateDistance() < 5){
  //   myOtherMotor->run(RELEASE);
  //   myMotor->run(RELEASE);
  //   exit(0);
  // }
}

void loop() {
  lservo.write(180);
  rservo.write(0);
  int perek = 0;
  // perek = line_cross();
  int up = 0;
  int down = 0;
  int count_lines = 0;
  proezd(400,70,70);
  perek = line_cross();
  while ( count_lines < 6)
  {
    // proezd_bwd(50,120,120);
    proezd(120,50,50);
    line_time(550);
    turn_2wd(9);
    Serial.println("forward");
    // perek = line_cross();
    line_time(1000);
    delay(500);
    Serial.println("read");
    if(analogRead(Su)<100)
    {
      up = 1;
    }
    if(analogRead(Sd)<100)
    {
      down = 1;
    }
    delay(1500);
    Serial.println("back and open");
    proezd_bwd(500,70,70);
    if(up==1)
    {
      rservo.write(180);
      delay(600);
      up = 0;
    }
    if(down==1)
    {
      lservo.write(10);
      delay(600);
      down = 0;
    }
    Serial.println("push");
    line_time(500);
    Serial.println("back to line");
    proezd_bwd(970,70,70);
    turn_2wd(1);
    Serial.println("prepare new cycle");
    proezd_bwd(400,70,70);
    perek = line_cross();
    lservo.write(180);
    rservo.write(0);
    count_lines++;
    Serial.println(count_lines);
  }

  proezd(1000,60,60);
  exit(0);

  // }
}

int line_obstacle() {
  myMotor->run(FORWARD);
  myOtherMotor->run(FORWARD);
  bool usl = 0;
  int t_start = millis();
  int t_banka=0;
  while (usl == 0) {
    if (calculateDistance() < 3) {
      usl = 1;
    }
    line();
  }
  t_banka=millis()-t_start;
  //Serial.println(t_banka);
  myOtherMotor->run(RELEASE);
  myMotor->run(RELEASE);
  bum.setTurnSignal(BUM_TURN_EMERGENCY);
  delay(500);
  bum.setTurnSignal(BUM_TURN_OFF);
  return t_banka;
}

int calculateDistance() {

  digitalWrite(Trig1, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(Trig1, HIGH);
  delayMicroseconds(10);
  digitalWrite(Trig1, LOW);
  duration = pulseIn(Echo1, HIGH);  // Reads the echoPin, returns the sound wave travel time in microseconds
  distance = duration * 0.034 / 2;
  return distance;
}
